For AI agents: A markdown version of this page is available at https://docs.datadoghq.com/api/latest/static-analysis/update-an-ai-custom-ruleset.md. A documentation index is available at /llms.txt.

Update an AI custom ruleset

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

PATCH https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.datadoghq.eu/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.uk1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}

Overview

Update the description of an existing AI custom ruleset.

Arguments

Path Parameters

Name

Type

Description

ruleset_name [required]

string

The ruleset name.

Request

Body Data (required)

Expand All

Field

Type

Description

data

object

Request data for updating an AI custom ruleset.

attributes

object

Attributes for updating an AI custom ruleset.

description

string

Base64-encoded full description of the ruleset.

name

string

The ruleset name.

short_description

string

Base64-encoded short description of the ruleset.

id

string

The ruleset identifier.

type

enum

AI custom ruleset resource type. Allowed enum values: ai_ruleset

{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}

Response

Successfully updated

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Precondition Failed - validation error or ruleset not found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Internal Server Error

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Code Example

                  ## default
# 

# Path parameters
export ruleset_name="my-ai-ruleset"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PATCH "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets/${ruleset_name}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "description": "Ruleset description", "name": "my-ai-ruleset", "short_description": "Ruleset short description" }, "id": "my-ai-ruleset", "type": "ai_ruleset" } } EOF
"""
Update an AI custom ruleset returns "Successfully updated" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi
from datadog_api_client.v2.model.ai_custom_ruleset_data_type import AiCustomRulesetDataType
from datadog_api_client.v2.model.ai_custom_ruleset_update_attributes import AiCustomRulesetUpdateAttributes
from datadog_api_client.v2.model.ai_custom_ruleset_update_data import AiCustomRulesetUpdateData
from datadog_api_client.v2.model.ai_custom_ruleset_update_request import AiCustomRulesetUpdateRequest

body = AiCustomRulesetUpdateRequest(
    data=AiCustomRulesetUpdateData(
        attributes=AiCustomRulesetUpdateAttributes(
            description="Ruleset description",
            name="my-ai-ruleset",
            short_description="Ruleset short description",
        ),
        id="my-ai-ruleset",
        type=AiCustomRulesetDataType.AI_RULESET,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["update_ai_custom_ruleset"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    api_instance.update_ai_custom_ruleset(ruleset_name="my-ai-ruleset", body=body)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Update an AI custom ruleset returns "Successfully updated" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.update_ai_custom_ruleset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new

body = DatadogAPIClient::V2::AiCustomRulesetUpdateRequest.new({
  data: DatadogAPIClient::V2::AiCustomRulesetUpdateData.new({
    attributes: DatadogAPIClient::V2::AiCustomRulesetUpdateAttributes.new({
      description: "Ruleset description",
      name: "my-ai-ruleset",
      short_description: "Ruleset short description",
    }),
    id: "my-ai-ruleset",
    type: DatadogAPIClient::V2::AiCustomRulesetDataType::AI_RULESET,
  }),
})
p api_instance.update_ai_custom_ruleset("my-ai-ruleset", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Update an AI custom ruleset returns "Successfully updated" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AiCustomRulesetUpdateRequest{
		Data: &datadogV2.AiCustomRulesetUpdateData{
			Attributes: &datadogV2.AiCustomRulesetUpdateAttributes{
				Description:      datadog.PtrString("Ruleset description"),
				Name:             datadog.PtrString("my-ai-ruleset"),
				ShortDescription: datadog.PtrString("Ruleset short description"),
			},
			Id:   datadog.PtrString("my-ai-ruleset"),
			Type: datadogV2.AICUSTOMRULESETDATATYPE_AI_RULESET.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateAiCustomRuleset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	r, err := api.UpdateAiCustomRuleset(ctx, "my-ai-ruleset", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.UpdateAiCustomRuleset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Update an AI custom ruleset returns "Successfully updated" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiCustomRulesetDataType;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateAttributes;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateData;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateRequest;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.updateAiCustomRuleset", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    AiCustomRulesetUpdateRequest body =
        new AiCustomRulesetUpdateRequest()
            .data(
                new AiCustomRulesetUpdateData()
                    .attributes(
                        new AiCustomRulesetUpdateAttributes()
                            .description("Ruleset description")
                            .name("my-ai-ruleset")
                            .shortDescription("Ruleset short description"))
                    .id("my-ai-ruleset")
                    .type(AiCustomRulesetDataType.AI_RULESET));

    try {
      apiInstance.updateAiCustomRuleset("my-ai-ruleset", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#updateAiCustomRuleset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Update an AI custom ruleset returns "Successfully updated" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;
use datadog_api_client::datadogV2::model::AiCustomRulesetDataType;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateAttributes;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateData;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateRequest;

#[tokio::main]
async fn main() {
    let body = AiCustomRulesetUpdateRequest::new().data(
        AiCustomRulesetUpdateData::new()
            .attributes(
                AiCustomRulesetUpdateAttributes::new()
                    .description("Ruleset description".to_string())
                    .name("my-ai-ruleset".to_string())
                    .short_description("Ruleset short description".to_string()),
            )
            .id("my-ai-ruleset".to_string())
            .type_(AiCustomRulesetDataType::AI_RULESET),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateAiCustomRuleset", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api
        .update_ai_custom_ruleset("my-ai-ruleset".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Update an AI custom ruleset returns "Successfully updated" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.updateAiCustomRuleset"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

const params: v2.StaticAnalysisApiUpdateAiCustomRulesetRequest = {
  body: {
    data: {
      attributes: {
        description: "Ruleset description",
        name: "my-ai-ruleset",
        shortDescription: "Ruleset short description",
      },
      id: "my-ai-ruleset",
      type: "ai_ruleset",
    },
  },
  rulesetName: "my-ai-ruleset",
};

apiInstance
  .updateAiCustomRuleset(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"